//
// Module: 	INIT_9_RAM32x1s
// Design: 	CAM_Top
// Verilog code:	RTL / Combinatorial
//
// Synthesis_tool	Synopsys FPGA Express ver. 3.6 
//	 	        Enable Synthesis Option: Verilog Pre-procesor
//
// Description: Basic building block of a CAM using Select BlockRAM & Select RAM
//		Instantiate 9 RAM32x1s_1 for ERASE operation
//		Initialization of RAM32x1s: attributes to constraint PAR and simulation
//
//
//
// Device: 	VIRTEX-II Families
//
// Created by: Lakshmi Gopalakrishnan & Jean-Louis BRELET / XILINX - VIRTEX-II Applications
// 
// Date: July 25,2001
// Version: 1.0
//
// 
//
//   Disclaimer:  THESE DESIGNS ARE PROVIDED "AS IS" WITH NO WARRANTY 
//                WHATSOEVER AND XILINX SPECIFICALLY DISCLAIMS ANY 
//                IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR
//                A PARTICULAR PURPOSE, OR AGAINST INFRINGEMENT.
//
//  Copyright (c) 1999 Xilinx, Inc.  All rights reserved.
//////////////////////////////////////////////////////////////////////////////////////////////////////-

`timescale 1 ns/100 ps
module INIT_9_RAM32x1s (DATA_IN, 
                        ADDR,          // Used by erase/write operation only
                        WRITE_RAM,     // If '1' DATA_IN is WRITE in the RAM_B4
                        CLK,
                        DATA_WRITE);
                        
                        
input CLK, WRITE_RAM;
input [8:0] DATA_IN;
input [4:0] ADDR;
output [8:0] DATA_WRITE;

//reg [8:0] DATA_WRITE;

//synopsys dc_script_begin
//set_attribute RAM_ERASE_0 INIT
//"00000000"
//set_attribute RAM_ERASE_1 INIT
//"00000000"
//set_attribute RAM_ERASE_2 INIT
//"00000000"
//set_attribute RAM_ERASE_3 INIT
//"00000000"
//set_attribute RAM_ERASE_4 INIT/
//"00000000"
//set_attribute RAM_ERASE_5 INIT
//"00000000"
//set_attribute RAM_ERASE_6 INIT
//"00000000"
//set_attribute RAM_ERASE_7 INIT
//"00000000"
//set_attribute RAM_ERASE_8 INIT
//"00000000"
//synopsys dc_script_end


RAM32X1S_1 RAM_ERASE_0 (.WE(WRITE_RAM), .WCLK(CLK), .D(DATA_IN[0]), 
                                .A0(ADDR[0]), .A1(ADDR[1]), .A2(ADDR[2]),
                                .A3(ADDR[3]), .A4(ADDR[4]), .O(DATA_WRITE[0]));
                                

RAM32X1S_1 RAM_ERASE_1 (.WE(WRITE_RAM), .WCLK(CLK), .D(DATA_IN[1]), 
                                .A0(ADDR[0]), .A1(ADDR[1]), .A2(ADDR[2]),
                                .A3(ADDR[3]), .A4(ADDR[4]),.O(DATA_WRITE[1])); 
                                

RAM32X1S_1 RAM_ERASE_2 (.WE(WRITE_RAM), .WCLK(CLK), .D(DATA_IN[2]), 
                                .A0(ADDR[0]), .A1(ADDR[1]), .A2(ADDR[2]),
                                .A3(ADDR[3]), .A4(ADDR[4]),.O(DATA_WRITE[2]));  

RAM32X1S_1 RAM_ERASE_3 (.WE(WRITE_RAM), .WCLK(CLK), .D(DATA_IN[3]), 
                                .A0(ADDR[0]), .A1(ADDR[1]), .A2(ADDR[2]),
                                .A3(ADDR[3]), .A4(ADDR[4]),.O(DATA_WRITE[3]));
                        
RAM32X1S_1 RAM_ERASE_4 (.WE(WRITE_RAM), .WCLK(CLK), .D(DATA_IN[4]), 
                                .A0(ADDR[0]), .A1(ADDR[1]), .A2(ADDR[2]),
                                .A3(ADDR[3]), .A4(ADDR[4]),.O(DATA_WRITE[4]));
                                
RAM32X1S_1 RAM_ERASE_5 (.WE(WRITE_RAM), .WCLK(CLK), .D(DATA_IN[5]), 
                                .A0(ADDR[0]), .A1(ADDR[1]), .A2(ADDR[2]),
                                .A3(ADDR[3]), .A4(ADDR[4]),.O(DATA_WRITE[5]));
                                
RAM32X1S_1 RAM_ERASE_6 (.WE(WRITE_RAM), .WCLK(CLK), .D(DATA_IN[6]), 
                                .A0(ADDR[0]), .A1(ADDR[1]), .A2(ADDR[2]),
                                .A3(ADDR[3]), .A4(ADDR[4]),.O(DATA_WRITE[6]));
                                
RAM32X1S_1 RAM_ERASE_7 (.WE(WRITE_RAM), .WCLK(CLK), .D(DATA_IN[7]), 
                                .A0(ADDR[0]), .A1(ADDR[1]), .A2(ADDR[2]),
                                .A3(ADDR[3]), .A4(ADDR[4]),.O(DATA_WRITE[7]));

RAM32X1S_1 RAM_ERASE_8 (.WE(WRITE_RAM), .WCLK(CLK), .D(DATA_IN[8]), 
                                .A0(ADDR[0]), .A1(ADDR[1]), .A2(ADDR[2]),
                                .A3(ADDR[3]), .A4(ADDR[4]),.O(DATA_WRITE[8]));
                                
//synopsys translate_off

defparam RAM_ERASE_0.INIT = 32'h00000000;

defparam RAM_ERASE_1.INIT = 32'h00000000;

defparam RAM_ERASE_2.INIT = 32'h00000000;

defparam RAM_ERASE_3.INIT = 32'h00000000;

defparam RAM_ERASE_4.INIT = 32'h00000000;

defparam RAM_ERASE_5.INIT = 32'h00000000;

defparam RAM_ERASE_6.INIT = 32'h00000000;

defparam RAM_ERASE_7.INIT = 32'h00000000;

defparam RAM_ERASE_8.INIT = 32'h00000000;

//synopsys translate_on
                                
endmodule // INIT_9_RAM32x1s


